package com.uwyn.jhighlight.highlighter;

import java.io.Reader;
import java.io.IOException;

%%

%class PropertiesHighlighter
%implements ExplicitStateHighlighter

%unicode
%pack

%buffer 128

%public

%int

%{
        /* styles */

        public static final byte PLAIN_STYLE = 1;
        public static final byte NAME_STYLE = 2;
        public static final byte VALUE_STYLE = 3;
        public static final byte COMMENT_STYLE = 4;

        /* Highlighter implementation */

        public byte getStartState() {
                return YYINITIAL+1;
        }

        public byte getCurrentState() {
                return (byte) (yystate()+1);
        }

        public void setState(byte newState) {
                yybegin(newState-1);
        }

        public byte getNextToken() throws IOException {
                return (byte) yylex();
        }

        public int getTokenLength() {
                return yylength();
        }

        public void setReader(Reader r) {
                this.zzReader = r;
        }

        public PropertiesHighlighter() {
        }
%}

WhiteSpace = [ \t\f]

%state IN_VALUE

%%

<YYINITIAL> {
  "\n"                           { yybegin(YYINITIAL); return PLAIN_STYLE; }

  {WhiteSpace}                   { return PLAIN_STYLE; }

  [^=\n\t\f ]+                   { return NAME_STYLE; }
  
  "="                            { yybegin(IN_VALUE);  return PLAIN_STYLE;}

  [#!] [^\n]* \n                 { return COMMENT_STYLE; }
}

<IN_VALUE> {
  "\\\n"                         { return VALUE_STYLE; }

  "\n"                           { yybegin(YYINITIAL); return PLAIN_STYLE; }

  [^\\\n]+                       { return VALUE_STYLE; }
}

/* error fallback */

.|\n                             { return PLAIN_STYLE; }

